# root.rb エンジンが最初に読み込むrubyスクリプト

loadscript "system.rb"

def Game.initialize
	Game.caption "Pad Game System 開発中のデモ"
	Task.add(:main,MyTask.new,0)
end

def Game.update
	Sprite.update
	Task.update
end

def Game.finalize
	Task.finalize
end

class MyTask < TaskObject
	Star_num=150 #星の数
	@@rnd=Random.new

	def initialize
		@f=Font.new(24,24,1000)
		@f.style(Font::FANCY,0xFF000000,0xFFFFFF00,0xFFFFFFFF)
		Sprite.load(:window,"*600,90,0x88000088")
		Sprite.text(:window,0,0,@f,"Ｐａｄ　Ｇａｍｅ　Ｓｙｓｔｅｍ　開発中のデモ")
		Sprite.text(:window,0,30,@f,"ＸＢＯＸパッドＡボタンもしくはＺキーで方向転換")
		Sprite.text(:window,0,60,@f,"ＸＢＯＸパッドＢボタンもしくはＸキーでボイス停止")
		Sprite.load(:star,"star.png")	
		Sprite.load(:movietex,"test.nmv",true,true)
		@snd=Sound.new
		@snd.load("00000.ogg")
		@snd.play(true)
		@x=[]
		@y=[]
		@scale=[]
		@rot=[]
		@vx=[]
		@vy=[]
		@vr=[]
		for i in 0..Star_num do
			@x[i]=@@rnd.rand(1024)
			@y[i]=@@rnd.rand(768)
			@rot[i]=0
			@scale[i]=0.5+@@rnd.rand(150)/100.0
			@vx[i]=(@@rnd.rand(5)-2)*4
			@vy[i]=(@@rnd.rand(5)-2)*4
			@vr[i]=(@@rnd.rand(7)*2-7)*0.1
		end
	end

	def update
		if Input.getpad(0,Input::A)==2 then
			for i in 0..Star_num do
				@vx[i]=(@@rnd.rand(5)-2)*4
				@vy[i]=(@@rnd.rand(5)-2)*4
				@vr[i]=(@@rnd.rand(7)-3)*0.1
			end
		end
		if Input.getpad(0,Input::B)==2 then
			@snd.fadeout(1000)
		end
		for i in 0..Star_num do
			@x[i]=@x[i]+@vx[i]
			@y[i]=@y[i]+@vy[i]
			@rot[i]=@rot[i]+@vr[i]
			if @x[i]>1024 || @x[i]<0 then @vx[i]=-@vx[i] end
			if @y[i]>768 || @y[i]<0 then @vy[i]=-@vy[i] end
			Draw.to(@x[i],@y[i])
			Draw.lt(@scale[i],@scale[i],@rot[i])
			Sprite.draw(:star,0)
			if i==(Star_num/2).floor then
					Draw.to(200,100)
					Sprite.draw(:movietex,0)
			end
		end
		Draw.to(0,0)
		Sprite.draw(:window,0)
	end

	def delete
	end
end

Game.window(1024,768) #これは無限ループです。
